#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct CustomTimeframeFilter {
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::UtcTimestamp>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "startTime", skip_serializing_if = "Option::is_none", default)]
    start_time: Option<Box<super::UtcTimestamp>>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::UtcTimestamp>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "endTime", skip_serializing_if = "Option::is_none", default)]
    end_time: Option<Box<super::UtcTimestamp>>,
}
impl CustomTimeframeFilter {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new() -> Self {
        Self::builder().build()
    }
    #[inline]
    pub fn start_time(&self) -> Option<&super::UtcTimestamp> {
        self.start_time.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn end_time(&self) -> Option<&super::UtcTimestamp> {
        self.end_time.as_ref().map(|o| &**o)
    }
}
